/*
   Author: Mark A. Hassman (mark@lost.strange.com)
   Version: 1.0
   Copyright:  GNU General Public License
*/
#include "copyright.h"


// Dice.cpp

// Includes all necessary functions when dealing 
// with dice and die strings such as 8d4.

#include "gma.h"
#include <string.h>

// decrypt_diestr()
// Takes a character pointer and returns a sum
// based on the decrypted iterations and die size.
// Returns -1 if string is improperly formatted
// Returns 0 if iterations or die size are 0.

float decrypt_diestr(char *instr)
{
	float sum=0, i=0, dice=0;
	char *ptr;

#ifdef DEBUG
	printf("Instr: %s\n", instr);
#endif

	// We check for a d or D
	// If neither exists, function exits.
	ptr=strchr(instr,'d');
	if(!ptr)
	  ptr=strchr(instr,'D');
	if(!ptr)
		return atof(instr);
	
	*ptr++ = '\0';
	i=atof(instr);
	dice=atof(ptr);

#ifdef DEBUG
	printf("%1.0f d %1.0f\n", i, dice);
#endif

	// If either of these is wrong
	// return 0;
	if(i <= 0 || dice <= 0)
		return 0;

	for(;i>0;i--)
		sum += D( (int) dice);
#ifdef DEBUG
	printf("Result %1.0f\n", sum);
#endif

	return sum;
}


