/*
   Author: Mark A. Hassman (mark@lost.strange.com)
   Version: 1.0
   Copyright:  GNU General Public License
*/
#include "copyright.h"

// fde.cpp  Functions to generate a fast & dirty expendable
// Mark A. Hassman 1/17/97

#include "gma.h"
#include "fde.h"
#include <string.h>
#include "cgic.h"

int 
roll_stat(void)
{
  int roll;
  roll = D6 + D6;
  if (roll <= 10)
    return roll;
  else
    return roll_stat();
}

FDE::FDE()
{
  int i;

  role = Int = Ref = Tech = Cool = Attr = Luck = MA = 0;
  Body = Emp = 0;
  for (i = 0; i < 6; ++i)
    SP[i] = 0;
  strcpy(cybernetics, "");
  strcpy(gear, "");
  strcpy(armor,"");

  for (i = 0; i < 15; i++)
  {
    strcpy(skills[i].name, "");
    skills[i].score = 0;
  }
}

void FDE::
gen_stats(void)
{
  Int = roll_stat();
  Ref = roll_stat();
  Tech = roll_stat();
  Cool = roll_stat();
  Attr = roll_stat();
  Luck = roll_stat();
  MA = roll_stat();
  Body = roll_stat();
  Emp = roll_stat();

  switch(Body)
  {
  case 1:
  case 2:
	BTM=0;
	break;
  case 3:
  case 4:
	BTM=-1;
	break;
  case 5:
  case 6:
  case 7:
	BTM=-2;
	break;
  case 8:
  case 9:
	BTM=-3;
	break;
  case 10:
  default:
	BTM=-5;
	break;

  }
}

void FDE::
pick_role(void)
{
  // Interface to the form, set choice if not == random
  char *roles[] =
  {
    "Random",
    "Cop",
    "Solo",
    "Rocker",
    "Media",
    "Nomad",
    "Netrunner",
    "Tech",
    "Medtech",
    "Corp",
    "Fixer"
  };
  cgiFormSelectSingle("role", roles, 11, &role, 0);
  if (!role)
    role = D10;
}

void FDE::
gen_skills(void)
{
  int i, sum = 0;

  // Set career skills with random scores of 0-9
  for (i = 0; i < 10; i++)
  {
    skills[i].score = die(9);
    sum += skills[i].score;
  }
  sum = 40 - sum;

  // Spread the remaining points around.
  if (sum > 0)
  {
    while (sum)
    {
      i = D10 - 1;
      if (skills[i].score < 11)
      {
	skills[i].score++;
	sum--;
      }
    }
  }
  // Oops, ran over, lower the skills
  // a bit to equalize.
  if (sum < 0)
  {
    while (sum < 0)
    {
      i = D10 - 1;
      if (skills[i].score > 2)
      {
	skills[i].score--;
	sum++;
      }
    }
  }
  // Set up the career package skill names.
  switch (role)
  {
  case 1:
    strcpy(skills[0].name, "Authority");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Handgun");
    strcpy(skills[3].name, "Human Perception");
    strcpy(skills[4].name, "Athletics");
    strcpy(skills[5].name, "Education & Gen. Know");
    strcpy(skills[6].name, "Brawling");
    strcpy(skills[7].name, "Melee");
    strcpy(skills[8].name, "Interrogation");
    strcpy(skills[9].name, "Streetwise");
    break;
  case 2:
    strcpy(skills[0].name, "Combat Sense");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Handgun");
    strcpy(skills[3].name, "Brawling");
    strcpy(skills[4].name, "Melee");
    strcpy(skills[5].name, "Martial Arts");
    strcpy(skills[6].name, "Rifle");
    strcpy(skills[7].name, "Athletics");
    strcpy(skills[8].name, "Submachine gun");
    strcpy(skills[9].name, "Stealth");
    break;
  case 3:
    strcpy(skills[0].name, "Charismatic Leadership");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Perform");
    strcpy(skills[3].name, "Wardrobe & Style");
    strcpy(skills[4].name, "Composition");
    strcpy(skills[5].name, "Brawling");
    strcpy(skills[6].name, "Play Instrument");
    strcpy(skills[7].name, "Streetwise");
    strcpy(skills[8].name, "Persuasion");
    strcpy(skills[9].name, "Seduction");
    break;
  case 4:
    strcpy(skills[0].name, "Credibility");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Composition");
    strcpy(skills[3].name, "Education & Gen. Know");
    strcpy(skills[4].name, "Persuasion");
    strcpy(skills[5].name, "Human Perception");
    strcpy(skills[6].name, "Social");
    strcpy(skills[7].name, "Streetwise");
    strcpy(skills[8].name, "Photo & Film");
    strcpy(skills[9].name, "Interview");
    break;
  case 5:
    strcpy(skills[0].name, "Family");
    strcpy(skills[1].name, "Awareness Notice");
    strcpy(skills[2].name, "Endurance");
    strcpy(skills[3].name, "Melee");
    strcpy(skills[4].name, "Rifle");
    strcpy(skills[5].name, "Drive");
    strcpy(skills[6].name, "Basic Tech");
    strcpy(skills[7].name, "Wilderness Survival");
    strcpy(skills[8].name, "Brawling");
    strcpy(skills[9].name, "Athletics");
    break;
  case 6:
    strcpy(skills[0].name, "Interface");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Basic Tech");
    strcpy(skills[3].name, "Education & Gen. Know");
    strcpy(skills[4].name, "System Knowledge");
    strcpy(skills[5].name, "CyberTech");
    strcpy(skills[6].name, "CyberDeck Design");
    strcpy(skills[7].name, "Composition");
    strcpy(skills[8].name, "Electronics");
    strcpy(skills[9].name, "Programming");
    break;
  case 7:
    strcpy(skills[0].name, "Jury Rig");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Basic Tech");
    strcpy(skills[3].name, "Cyber Tech");
    strcpy(skills[4].name, "Teaching");
    strcpy(skills[5].name, "Education & Gen. Know");
    strcpy(skills[6].name, "Electronics");
    strcpy(skills[7].name, (die(2) - 1) ? "Gyro Tech" : "Aero Tech");
    strcpy(skills[8].name, "Weaponsmith");
    strcpy(skills[9].name, "Electronic Security");
    break;
  case 8:
    strcpy(skills[0].name, "Medical Tech");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Basic Tech");
    strcpy(skills[3].name, "Diagnose Illness");
    strcpy(skills[4].name, "Education & Gen. Know");
    strcpy(skills[5].name, "Cryotank Operation");
    strcpy(skills[6].name, "Library Search");
    strcpy(skills[7].name, "Pharmaceuticals");
    strcpy(skills[8].name, "Zoology");
    strcpy(skills[9].name, "Human Perception");
    break;
  case 9:
    strcpy(skills[0].name, "Resources");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Human Perception");
    strcpy(skills[3].name, "Education & Gen. Know");
    strcpy(skills[4].name, "Library Search");
    strcpy(skills[5].name, "Social");
    strcpy(skills[6].name, "Persuasion");
    strcpy(skills[7].name, "Stock Market");
    strcpy(skills[8].name, "Wardrobe & Style");
    strcpy(skills[9].name, "Personal Grooming");
    break;
  case 10:
    strcpy(skills[0].name, "Streetdeal");
    strcpy(skills[1].name, "Awareness/Notice");
    strcpy(skills[2].name, "Forgery");
    strcpy(skills[3].name, "Handgun");
    strcpy(skills[4].name, "Brawling");
    strcpy(skills[5].name, "Melee");
    strcpy(skills[6].name, "Pick Pocket");
    strcpy(skills[7].name, "Pick Lock");
    strcpy(skills[8].name, "Intimidate");
    strcpy(skills[9].name, "Persuasion");
    break;
  }
  gen_adv_skills();
}


void FDE::
gen_gear(void)
{
  int mod, i;

  for (i = 0; i < 6; ++i)
    SP[i] = 0;

  if (role == SOLO)
    mod = 3;
  else if (role == NOMAD || role == COP)
    mod = 2;
  else
    mod = 0;
  // Descriptive, SP locs vals, EV mods

  switch (D10 + mod)
  {
  case 1:
    strcpy(armor, "<i>Heavy Leathers</i>");
    SP[1] = SP[2] = SP[3] = 4;
    // No EV mods
    EV=0;
    break;
  case 2:
    strcpy(armor, "<i>Armor Vest</i>");
    SP[1] = 10;
    EV=0;
    break;
  case 3:
  case 4:
    strcpy(armor, "<i>Light Armor Jacket</i>");
    SP[1] = SP[2] = SP[3] = 14;
    break;
  case 5:
  case 6:
  case 7:
    strcpy(armor, "<i>Medium Armor Jacket</i>");
    SP[1] = SP[2] = SP[3] = 18;
    EV=1;
    break;
  case 8:
  case 9:
    strcpy(armor, "<i>Heavy Armor Jacket</i>");
    SP[1] = SP[2] = SP[3] = 20;
    EV=2;
    break;
  default:
    strcpy(armor, "<i>Metal Gear</i>");
    for (i = 0; i < 6; ++i)
      SP[i] = 25;
    EV=2;
    break;
  }
  if(Ref > EV)
	EV = Ref - EV;
  else
     EV = 1;


  switch (D10 + mod)
  {
  case 1:
    W.gen_weapon(MELEE);
    break;
  case 2:
  case 3:
  case 4:
  case 5:
    W.gen_weapon(PISTOL);
    break;
  case 6:
    W.gen_weapon(SMG);
    break;
  case 7:
  case 8:
  case 9:
  case 10:
  default:
    switch(D10)
    {
      case 1:
        W.gen_weapon(SHOTGUN);
        break;
      default:
    	W.gen_weapon(RIFLE);
    	break;
    }
  }
}

void FDE::
display_fde(void)
{
  int i;

  fprintf(cgiOut, "Name: %-30s", N.fullname);
  fprintf(cgiOut, "Role: ");
  switch (role)
  {
  case 1:
    fprintf(cgiOut, "Cop\n");
    break;
  case 2:
    fprintf(cgiOut, "Solo\n");
    break;
  case 3:
    fprintf(cgiOut, "Rockerboy\n");
    break;
  case 4:
    fprintf(cgiOut, "Media\n");
    break;
  case 5:
    fprintf(cgiOut, "Nomad\n");
    break;
  case 6:
    fprintf(cgiOut, "Netrunner\n");
    break;
  case 7:
    fprintf(cgiOut, "Techie\n");
    break;
  case 8:
    fprintf(cgiOut, "Med Techie\n");
    break;
  case 9:
    fprintf(cgiOut, "Corporate\n");
    break;
  case 10:
    fprintf(cgiOut, "Fixer\n");
    break;
  }
  fprintf(cgiOut, "Age: %2d\n", age);
  fprintf(cgiOut, "Stats: INT[%2d]  REF[%2d]  TECH[%2d] COOL[%2d]\n", Int, Ref, Tech, Cool);
  fprintf(cgiOut, "      ATTR[%2d] LUCK[%2d]    MA[%2d] BODY[%2d]\n", Attr, Luck, MA, Body);
  fprintf(cgiOut, "       EMP[%2d]  RUN[%2d]  LEAP[%2d] LIFT[%2d]\n", Emp, MA * 5, MA / 4, Body * 5);

  fprintf(cgiOut, "Armor (SP):\n");
  fprintf(cgiOut, "   Head  Torso  R.Arm  L.Arm  R.Leg  L.Leg\n");
  fprintf(cgiOut, "  [ 1 ]  [2-4]  [ 5 ]  [ 6 ]  [7-8]  [9-0]\n");
  fprintf(cgiOut, "  [%3d]  [%3d]  [%3d]  [%3d]  [%3d]  [%3d]\n",
	  SP[0], SP[1], SP[2], SP[3], SP[4], SP[5]);
/*      fprintf(cgiOut,"\tHead  [ 1 ]: %2d\t", SP[0]);
   fprintf(cgiOut,"\tTorso [2-4]: %2d\n", SP[1]);
   fprintf(cgiOut,"\tR.Arm [ 5 ]: %2d\t", SP[2]);
   fprintf(cgiOut,"\tL.Arm [ 6 ]: %2d\n", SP[3]);
   fprintf(cgiOut,"\tR.Leg [7-8]: %2d\t", SP[4]);
   fprintf(cgiOut,"\tL.Leg [9-0]: %2d\n", SP[5]); */
  //fprintf(cgiOut,"\n");
  fprintf(cgiOut, "Skills:\n");
  for (i = 0; i < 14; i += 2)
  {
    fprintf(cgiOut, " %-28s: %2d", skills[i].name, skills[i].score);
    fprintf(cgiOut, "    %-28s: %2d\n", skills[i + 1].name, skills[i + 1].score);
  }
  fprintf(cgiOut, " %-28s: %2d\n", skills[14].name, skills[14].score);

  fprintf(cgiOut, "\n");
  fprintf(cgiOut, "Cybernetics: %s\n", cybernetics);
  fprintf(cgiOut, "Gear: %s\n", gear);
}

void FDE::gen_fde(void)
{
  char *SexChoice[] = { "Random", "Male", "Female"};
  char *NameChoice[] = { "Off", "On" };
  int gender;

  cgiFormSelectSingle("gender", SexChoice, 3, &gender, 0);
  if(gender)
    sex=gender;
  else
    sex=die(2);

  gen_stats();
  pick_role();
  set_age();
  gen_skills();
  gen_cyberwear();
  gen_gear();
  cgiFormSelectSingle("name-generation", NameChoice, 2, &gen_name, 0);
  if(gen_name)
     N.gen_fullname(gender);
  
}

void FDE::gen_adv_skills(void)
{
  char buff[81];
  FILE *Data;
  int roll = 0, i, j, k, skill_cnt = 0, match = 0;
  char *OnOff[] = { "Off", "On" };

  strcpy(buff, "Foo");
  // Open the data file abort if not present.
  Data = fopen("/home/data/punk/skills.dat", "r");
  if (!Data)
  {
    fprintf(cgiOut, "Error opening skills data file in gen_adv_skills.\n");
    exit(-4);
  }
  // Count the number of skills in the data file.
  while (Data && buff[0] != '\n')
  {
    fgets(buff, 80, Data);
    if (buff[0])
      skill_cnt++;
  }
  skill_cnt--;
  fclose(Data);
  Data = fopen("/home/data/punk/skills.dat", "r");

  // Add in pickup skill names.
  for (j = 10; j < 15; ++j)
  {
    skills[j].score = 1;
    roll = die(skill_cnt);
    i = 0;
    while (i++ != roll)
      fgets(buff, 80, Data);
    buff[strlen(buff) - 1] = '\0';


    // No duplicate skills please
    match = 0;
    for (k = j - 1; k >= 0; k--)
    {
      if (!strncmp(skills[k].name, buff, strlen(skills[k].name) - 2))
      {
	j--;
	match = 1;
      }
    }
    if (!match)
      strcpy(skills[j].name, buff);
    freopen("/home/data/punk/skills.dat", "r", Data);
  }


  // Okay, let's spread additional skill points
  i = Int + D10;
  if (i > 0)
  {
    while (i--)
    {
      j = die(15) - 1;
      if (skills[j].score < 10)
	skills[j].score++;
      else
	i++;
    }
  }
  // Lets give extra points based on age, 1/year if age > 16
  // and if advanced skill points are flagged on.
  cgiFormSelectSingle("asp", OnOff, 2, &j, 0);
 
  if (age > 16 && j)
    i = age - 16;
  else
    i = 0;

  while (i--)
  {
    j = die(15) - 1;		// We have 15 skills 0-14

    if (skills[j].score < 10)
      skills[j].score++;
    else
      i++;
  }

  fclose(Data);
}

void FDE::
set_age(void)
{
  int min, max;

  max = min = 0;

  cgiFormIntegerBounded("min-age", &min, 8, 100, 16);
  cgiFormIntegerBounded("max-age", &max, min, 100, 28);

  if (min == max)
    age = min;
  else
    age = die(max - min) + min;

}

void FDE::
display_fde_html(void)
{
  int i;  char namebuf[80];
  cgiHeaderContentType("text/html");
  fprintf(cgiOut, "<html><head><title>CP2020 FDE Generator</title></head>\n");
  fprintf(cgiOut, "<body bgcolor=#ffffff link=#000000 vlink=#000000>\n");
  fprintf(cgiOut, "<center><table border=1>");
  fprintf(cgiOut, "<tr><td colspan=9 bgcolor=#DDDDDD align=center>\n");
  fprintf(cgiOut, "<font size=+1>Fast & Dirty Expendable Generator</font><br>\n");
  fprintf(cgiOut, "<font size=-1><a href=\"http://lost.strange.com/cp2020/fde-form.html\">");
  fprintf(cgiOut, "http://lost.strange.com/cp2020/fde-form.html</a></font>\n");
  fprintf(cgiOut, "</td></tr>\n");
  fprintf(cgiOut, "<tr><td><b>Name</b></td>\n");
  if(gen_name)
     fprintf(cgiOut, "<td colspan=2>%s</td>\n", N.fullname);
  else
  {
     cgiFormStringNoNewlines("in-name", namebuf, 79);
     fprintf(cgiOut, "<td colspan=2>%s</td>\n", namebuf);
  }   
  
  fprintf(cgiOut, "<td><b>Role</b></td><td>");
  switch (role)
  {
  case 1:
    fprintf(cgiOut, "Cop\n");
    break;
  case 2:
    fprintf(cgiOut, "Solo\n");
    break;
  case 3:
    fprintf(cgiOut, "Rockerboy\n");
    break;
  case 4:
    fprintf(cgiOut, "Media\n");
    break;
  case 5:
    fprintf(cgiOut, "Nomad\n");
    break;
  case 6:
    fprintf(cgiOut, "Netrunner\n");
    break;
  case 7:
    fprintf(cgiOut, "Techie\n");
    break;
  case 8:
    fprintf(cgiOut, "Med Techie\n");
    break;
  case 9:
    fprintf(cgiOut, "Corporate\n");
    break;
  case 10:
    fprintf(cgiOut, "Fixer\n");
    break;
  }
  fprintf(cgiOut,"</td>");
  if(sex == MALE)
    fprintf(cgiOut, "<td><b>Sex</b></td><td>Male</td>\n");
  else
    fprintf(cgiOut, "<td><b>Sex</b></td><td>Female</td>\n");

  fprintf(cgiOut, "<td><b>Age</b></td><td>%d</td>\n", age);
  fprintf(cgiOut, "<tr><td colspan=9 bgcolor=#DDDDDD align=center>\n");
  fprintf(cgiOut, "<font size=+1>Stats</font><br>\n");
  fprintf(cgiOut, "</td></tr>\n");
  fprintf(cgiOut, "<tr>");
  fprintf(cgiOut, "<td colspan=2>INT</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", Int);
  fprintf(cgiOut, "<td colspan=2>REF</td>");
  fprintf(cgiOut, "<td align=center>%d / %d</td>\n", EV, Ref);
  fprintf(cgiOut, "<td colspan=2>TECH</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", Tech);
  fprintf(cgiOut,"</tr>"); 
  fprintf(cgiOut, "<tr>");
  fprintf(cgiOut, "<td colspan=2>COOL</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", Cool);
  fprintf(cgiOut, "<td colspan=2>ATTR</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", Attr);
  fprintf(cgiOut, "<td colspan=2>LUCK</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", Luck);
  fprintf(cgiOut,"</tr>"); 
  fprintf(cgiOut, "<tr>");
  fprintf(cgiOut, "<td colspan=2>MA</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", MA);
  fprintf(cgiOut, "<td colspan=2>BODY</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", Body);
  fprintf(cgiOut, "<td colspan=2>EMP</td>");
  fprintf(cgiOut, "<td align=center>%d / %d</td>\n",Emp - (int) (HL/10), Emp);
  fprintf(cgiOut,"</tr>"); 
  fprintf(cgiOut, "<tr>");
  fprintf(cgiOut, "<td colspan=2>RUN</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", MA*5);
  fprintf(cgiOut, "<td colspan=2>LEAP</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", MA/4);
  fprintf(cgiOut, "<td colspan=2>LIFT</td>");
  fprintf(cgiOut, "<td align=center>%d</td>\n", Body*5);
  fprintf(cgiOut,"</tr>"); 


  fprintf(cgiOut, "<tr><td colspan=9 bgcolor=#DDDDDD align=center>\n");
  fprintf(cgiOut, "<font size=+1>Armor: %s</font>\n", armor);
  fprintf(cgiOut, "</td></tr>\n");
  fprintf(cgiOut, "<tr><td colspan=3><b>Location</b></td>\n");
  fprintf(cgiOut, "<td align=center>Head<br>1</td>\n");
  fprintf(cgiOut, "<td align=center>Torso<br>2-4</td>\n");
  fprintf(cgiOut, "<td align=center>R. Arm<br>5</td>\n");
  fprintf(cgiOut, "<td align=center>L. Arm<br>6</td>\n");
  fprintf(cgiOut, "<td align=center>R. Leg<br>7-8</td>\n");
  fprintf(cgiOut, "<td align=center>L. Leg<br>9-0</td>\n");
  fprintf(cgiOut, "</tr><tr>\n");
  fprintf(cgiOut, "<td colspan=3><b>Armor SP</b></td>\n");
  fprintf(cgiOut, "<td align=center>%3d</td>\n", SP[0]);
  fprintf(cgiOut, "<td align=center>%3d</td>\n", SP[1]);
  fprintf(cgiOut, "<td align=center>%3d</td>\n", SP[2]);
  fprintf(cgiOut, "<td align=center>%3d</td>\n", SP[3]);
  fprintf(cgiOut, "<td align=center>%3d</td>\n", SP[4]);
  fprintf(cgiOut, "<td align=center>%3d</td>\n", SP[5]);
  fprintf(cgiOut, "</tr>\n");
  fprintf(cgiOut, "<tr><td align=center><b>Save</b></td>");
  fprintf(cgiOut, "<td align=center><b>BTM<b></td>\n");
  fprintf(cgiOut, "<td rowspan=2 colspan=7><center>");
  fprintf(cgiOut, "<img src=\"http://lost.strange.com/images/cp-hits.gif\" alt=\"\" align=middle>\n");
  fprintf(cgiOut, "</center></td></tr>\n");
  fprintf(cgiOut, "<tr><td align=center>%d</td><td align=center>%d</td></tr>\n", Body, BTM);
  fprintf(cgiOut, "<tr><td colspan=9 bgcolor=#DDDDDD align=center>\n");

  fprintf(cgiOut, "<font size=+1>Skills</font><br>\n");
  fprintf(cgiOut, "</td></tr>\n");
  fprintf(cgiOut, "<tr><th colspan=2>Skill</th><th>Score</th><th colspan=2>Skill</th><th>Score</th><th colspan=2>Skill</th><th>Score</th></tr>");
  for (i = 0; i < 15; i += 3)
  {
    if(i==0)
    {
    fprintf(cgiOut, "<tr><td colspan=2><i>%s</i></td><td align=center>%d</td>\n",
	 skills[i].name, skills[i].score);
    }
    else
    fprintf(cgiOut, "<tr><td colspan=2>%s</td><td align=center>%d</td>\n",
	 skills[i].name, skills[i].score);
    fprintf(cgiOut, "<td colspan=2>%s</td><td align=center>%d</td>\n",
	skills[i + 1].name, skills[i + 1].score);
    fprintf(cgiOut, "<td colspan=2>%s</td><td align=center>%d</td></tr>\n", skills[i + 2].name, skills[i + 2].score);
  }


  fprintf(cgiOut, "<tr><td colspan=9 bgcolor=#DDDDDD align=center>\n");
  fprintf(cgiOut, "<font size=+1>Cybernetics</font><br>\n");
  fprintf(cgiOut, "</td></tr>\n");
  fprintf(cgiOut, "<tr><td colspan=9>%s</td></tr>\n", cybernetics);
//  fprintf(cgiOut, "<tr><td colspan=9 bgcolor=#DDDDDD align=center>\n");
//  fprintf(cgiOut, "<font size=+1>Gear</font> %s<br>\n");
//  fprintf(cgiOut, "<tr><td colspan=9>%s</td></tr>\n", gear);
  W.display_weapon_html();
  fprintf(cgiOut, "</table></center>\n");
  fprintf(cgiOut, "</body></html>\n");
}
