/*
   Author: Mark A. Hassman (mark@lost.strange.com)
   Version: 1.0
   Copyright:  GNU General Public License
*/
#include "copyright.h"

// fde.h -- Fast & Dirty Expendables for CP 2020
// 1/17/97 by M. Hassman

#ifndef FDE_H
#define FDE_H

#include "name.h"
#include "weapon.h"
#include "cgic.h"

// The various roles
#define	COP		1
#define SOLO		2
#define ROCKER		3
#define MEDIA		4
#define NOMAD		5
#define	NETRUNNER	6
#define TECH		7
#define MEDTECH		8
#define CORP		9
#define FIXER		10


#define MALE 		1
#define FEMALE  	2
struct SKILL
{
	char name[81];
	int score;
};

class FDE
{
private:
	class NAME N;
	int role;
	int age;
	int Int;
	int Ref;
	int Tech;
	int Cool;
	int Attr;
	int Luck;
	int MA;
	int Body;
	int BTM;
	int Emp;
	int EV;
	float HL;
	int SP[6];
	char cybernetics[512];
	char gear[256];
	char armor[81];
  	WEAPON W;
	SKILL skills[15];
	int advanced;
	int gen_name;
	void gen_cyberwear_opts(int, int);
public:
	FDE();
	int sex;
	void gen_stats(void);
	void pick_role(void);
	void gen_skills(void);
	void gen_adv_skills(void);
	void gen_cyberwear(void);
	void gen_gear(void);
	void display_fde(void);
	void display_fde_html(void);
	void gen_fde(void);
	void set_age(void);
};

int roll_stat(void);

#endif
