/*
   Author: Mark A. Hassman  (mark@lost.strange.com)
   Version: 1.0
   Copyright:  GNU General Public License
*/
#include "copyright.h"


#include "lifepath.h"

/* Generate the clothes for an NPC.  I don't typically use these for
  much as they are boring so we'll just run the standard gamete in
  the book. */

void Lifepath::gen_clothes(void)
{
  switch(D10)
  {
    case 1:
	strcpy(clothes,"Biker Leathers");
 	break;
    case 2:
	strcpy(clothes,"Blue Jeans");
	break;
    case 3:
	strcpy(clothes,"Corporate Suits");
	break;
    case 4:
	strcpy(clothes,"Miniskirts");
	break;
    case 5:
	strcpy(clothes,"High Fashion");
	break;
    case 6:
	strcpy(clothes,"Cammos");
	break;
    case 7:
	strcpy(clothes,"Normal Clothes");
	break;
    case 8:
	strcpy(clothes,"Nude");
	break;
    case 9:
	strcpy(clothes,"Jumpsuits");
	break;
    case 10:
	strcpy(clothes,"Ragged Clothes");
	break;
    default:
	strcpy(clothes,"Error in gen_clothes: lifepath.cpp");
	break;
  }
} /* End of gen_clothes() */

/* Simplistic hair, direct from the lifepath section of the text */
void Lifepath::gen_hairstyle(void)
{
  switch(D10)
  {
    case 1:
	strcpy(hairstyle,"Mohawk");
	break;
    case 2:
	strcpy(hairstyle,"Long and Ratty");
	break;
    case 3:
	strcpy(hairstyle,"Short and Spiked");
	break;
    case 4:
	strcpy(hairstyle,"Wild and All Over");
	break;
    case 5:
	strcpy(hairstyle,"Bald");
	break;
    case 6:
	strcpy(hairstyle,"Striped");
	break;
    case 7:
	strcpy(hairstyle,"Tinted");
	break;
    case 8:
	strcpy(hairstyle,"Short and Neat");
	break;
    case 9:
	strcpy(hairstyle,"Short and curly");
	break;
    case 10:
	strcpy(hairstyle,"Long and Straight");
	break;
    default:
	strcpy(hairstyle,"Error in gen_hairstyle: lifepath.cpp");
	break;
  }
}  /* End of gen_hairstyle() */

/* A few standard affections directly from the book */

void Lifepath::gen_affections(void)
{
  switch(D10)
  {
    case 1:
	strcpy(affections,"Tatoos");
	break;
    case 2:
	strcpy(affections,"Mirrorshades");
	break;
    case 3:
	strcpy(affections,"Scars");
	break;
    case 4:
	strcpy(affections,"Nose Rings");
	break;
    case 5:
	strcpy(affections,"Earrings");
	break;
    case 6:
	strcpy(affections,"Long Fingernails");
	break;
    case 7:
	strcpy(affections,"Spiked Gloves");
	break;
    case 8:
	strcpy(affections,"Spike Heel Boots");
	break;
    case 9:
	strcpy(affections,"Weird Contact Lenses");
	break;
    case 10:
	strcpy(affections,"Fingerless Gloves");
	break;
    default:
	strcpy(affections,"Error in gen_affections: lifepath.cpp");
	break;
  } 
} /* End of gen_affections() */

/* Simple ethnicity */
void Lifepath::gen_ethnicity(void)
{
  switch(D10)
  {
     case 1:
	strcpy(ethnicity,"Anglo-American");
	break;
     case 2:
	switch(D6)
	{
	   case 1:
		strcpy(ethnicity,"African: Bantu");
		break;
	   case 2:
		strcpy(ethnicity,"African: Fante");
		break;
	   case 3:
		strcpy(ethnicity,"African: Kongo");
		break;
	   case 4:
		strcpy(ethnicity,"African: Ashanti");
		break;
	   case 5:
		strcpy(ethnicity,"African: Zulu");
		break;
	   case 6: 
		strcpy(ethnicity,"African: Swahili");
		break;
	} /* end of african ethnicity switch */
	break;
    case 3:
	switch(die(2))
 	{
	  case 1:
		strcpy(ethnicity,"Japanese");
		break;
	  case 2:
		strcpy(ethnicity,"Korean");
		break;
	} /* end of jap/kor switch */
	break;
    case 4:  /* soviet bloc */
	switch(D6)
	{
	  case 1:
		strcpy(ethnicity,"Bulgarian");
		break;
	  case 2:
		strcpy(ethnicity,"Russian");
		break;
	  case 3:
		strcpy(ethnicity,"Czech");
		break;
	  case 4:
		strcpy(ethnicity,"Polish");
		break;
	  case 5:
		strcpy(ethnicity,"Ukranian");
		break;
	  case 6:
		strcpy(ethnicity,"Slovak");
		break;

	} /* End of soviet bloc switch */
	break;
    case 5: /* Pacific Islander */
	switch(die(7))
        {
	  case 1:
		strcpy(ethnicity,"Micronesian");
		break;
	  case 2:
		strcpy(ethnicity,"Tagalog");
		break;
	  case 3:
		strcpy(ethnicity,"Polynesian");
		break;
	  case 4:
		strcpy(ethnicity,"Malayan");
		break;
	  case 5:
		strcpy(ethnicity,"Sudanese");
		break;
	  case 6:
		strcpy(ethnicity,"Indonesian");
		break;
	  case 7:
		strcpy(ethnicity,"Hawaiian");
		break;
	} /* End of pacific islanders */
    case 6:  /* Chinese / SE Asia */
	switch(D6)
	{
	  case 1:
		strcpy(ethnicity,"Burmese");
		break;
	  case 2:
		strcpy(ethnicity,"Catonese");
		break;
	  case 3:
		strcpy(ethnicity,"Mandarin");
		break;
	  case 4:
		strcpy(ethnicity,"Thai");
		break;
	  case 5:
		strcpy(ethnicity,"Tibetan");
		break;
	  case 6:
		strcpy(ethnicity,"Vietnamese");
		break;
	} /* End of chinese/se asia switch */
    case 7:
	strcpy(ethnicity,"Black American");
	break;
    case 8:
	strcpy(ethnicity, "Hispanic American");
        break;
    case 9:
	strcpy(ethnicity, "Central/South American");
	break;
    case 10:
	switch(die(13))
   	{
	  case 1:
		strcpy(ethnicity,"French");
		break;
	  case 2:
		strcpy(ethnicity,"German");
		break;
	  case 3:
		strcpy(ethnicity,"English");
		break;
	  case 4:
		strcpy(ethnicity,"Spanish");
		break;
	  case 5:
		strcpy(ethnicity,"Italian");
		break;
	  case 6:
		strcpy(ethnicity,"Greek");
		break;
	  case 7:
		strcpy(ethnicity,"Danish");
		break;
	  case 8:
		strcpy(ethnicity,"Dutch");
		break;
	  case 9:
		strcpy(ethnicity,"Norwegian");
		break;
	  case 10:
		strcpy(ethnicity,"Swedish");
		break;
	  case 11:
		strcpy(ethnicity,"Finish");
		break;
	  case 12:
		strcpy(ethnicity,"Irish");
		break;
	  case 13:
		strcpy(ethnicity,"Scottish");
		break;

	} /* end of european types */
  } /* End of primary ethnicity switch */
} /* End of gen_ethnicity */

/* Family Background: Step II of Lifepath Generation 
 *
 * Functions Used:
 *    family_ranking()
 *    parents()
 *    parent_event()
 *    family_status()
 *    family_tragedy()
 *    child_environ()
 *    siblings()
 *
 *  We'll work step by step through the family generation.  Hopefully,
 *  the result will be legible.
 */
 
/* This is the initially called function. */
void Lifepath::family_ranking(void)
{
  // Init the array, to be safe
  strcpy(family_data,"<tr><td align=center><b>Rank</b></td><td>\n");
  
  // Since this is first, we can use strcpy.
  switch(D10)
  {
    case 1:
	strcat(family_data,"Corporate Executive.  ");
	break;
    case 2:
	strcat(family_data,"Corporate Manager.  ");
	break;
    case 3:
	strcat(family_data,"Corporate Technician. ");
	break;
    case 4:
	strcat(family_data,"Nomad Pack. ");
	break;
    case 5:
	strcat(family_data,"Pirate Fleet. ");
	break;
    case 6:
	strcat(family_data,"Gang Family. ");
	break;
    case 7:
	strcat(family_data,"Crime Lord");
	break;
    case 8:
	strcat(family_data,"Combat Zone Poor. ");
	break;
    case 9:
	strcat(family_data,"Urban Homeless. ");
	break;
    case 10:
	strcat(family_data,"Arcology Family. ");
	break;
  }
  strcat(family_data,"</td></tr>\n");
  // Move to Family Generation Step 2.
  parents();

} /* end of family_ranking */

// Parents: Step 2 of Family Generation
void Lifepath::parents(void)
{  
   strcat(family_data,"<tr><td align=center><b>Parents</td><td>\n");
   if( D10 < 7)
   {
     strcat(family_data, "Parents are both living.</td></tr>\n");
     // Branch: family_status

     family_status();
   }
   else
   {
     // Branch: Parental events
     parent_event();
   }
} // End of parents()

void Lifepath::parent_event(void)
{
  switch(D10)
  {
    case 1:
	strcat(family_data,"Your parent(s) died in warfare. ");
	break;
    case 2:
	strcat(family_data,"Your parent(s) died in an accident. ");
	break;
    case 3:
	strcat(family_data,"Your parent(s) were murdered. ");
	break;
    case 4:
	strcat(family_data,"Your parent(s) have amnesia and don't remember you. ");
	break;
    case 5:
	strcat(family_data,"You never knew your parents. ");
	break;
    case 6:
	strcat(family_data,"Your parent(s) are in hiding to protect you. ");
	break;
    case 7:
	strcat(family_data,"You were left with relatives for safekeeping. ");
	break;
    case 8:
	strcat(family_data,"You grew up on the street and never knew your parents. ");
	break;
    case 9:
	strcat(family_data,"Your parent(s) gave you up for adoption. ");
	break;
    case 10:
	strcat(family_data,"Your parent(s) sold you for money. ");
	break;
  }
  strcat(family_data,"</td></tr>\n");
  // Branch to family_status()

  family_status();
}

void Lifepath::family_status(void)
{
  strcat(family_data,"<tr><td align=center><b>Family Status</b></td><td>\n");
  if(die(10) < 7)
  {
   family_tragedy();
  }
  else
  {
   // Family status okay, off to childhood environ
   strcat(family_data,"Family status is okay.</td></tr>\n");
   child_environ();
  }
}

void Lifepath::child_environ(void)
{
  strcat(family_data,"<tr><td align=center><b>Childhood</b></td><td>\n");
  switch(D10)
  {
    case 1:
	strcat(family_data,"Spent life on street with no adult supervision. ");
	break;
    case 2:
	strcat(family_data,"Spent in a safe Corporate Suburbia. ");
	break;
    case 3:
	strcat(family_data,"In a nomad pack moving from town to town. ");
	break;
    case 4:
	strcat(family_data,"In a decaying, once upscale neighborhood. ");
	break;
    case 5:
	strcat(family_data,"In a defended Corporate Zone in the Central City. ");
	break;
    case 6:
	strcat(family_data,"In the heart of the Combat Zone. ");
	break;
    case 7:
	strcat(family_data,"In a small village or town far from the city. ");
	break;
    case 8:
	strcat(family_data,"In a large arcology city. ");
	break;
    case 9:
	strcat(family_data,"In a Pirate Pack. ");
	break;
    case 10:
	strcat(family_data,"On a corporate controlled farm or research facility. ");
	break;
  }
  strcat(family_data,"</td></tr>\n");
  // Branch to Siblings
 siblings();
}

void Lifepath::family_tragedy(void)
{
 switch(D10)
 {
   case 1:
     strcat(family_data,"Family lost everything through betrayal. ");
     break;
   case 2:
     strcat(family_data,"Family lost everything through bad management. ");
     break;
   case 3:
     strcat(family_data,"Family exiled or otherwise driven from their original home/nation/corporation. ");
     break;
   case 4:
     strcat(family_data,"Family is imprisoned and you alone escaped. ");
     break;
   case 5:
     strcat(family_data,"Family vanished. You are the only remaing member. ");
     break;
   case 6:
     strcat(family_data,"Family was murdered/killed and you were the sole survivor. ");
     break;
   case 7:
     strcat(family_data,"Family is involved in a longterm conspiracy, organization or associateion, such as a crime family or revolutionary group. ");
     break;
   case 8:
     strcat(family_data,"Your family is cursed with a hereditary fued that has lated for generations. ");
     break;
   case 9:
     strcat(family_data,"Your family was scattered to the winds due to misfortune. ");
     break;
   case 10:
     strcat(family_data,"You are the inheritor of a family debt; You must honor this debt before moving on with your life. ");
     break;
 }
 strcat(family_data,"</td></tr>\n");
 // Branch to childhood env
 child_environ();
}

void Lifepath::siblings(void)
{
  int roll=0, age_roll=0, feel_roll=0, sex_roll=0;
  char age_buff[41], sex_buff[41], feel_buff[41];  
  char full_string[HBUF];

  roll = D10;
  strcpy(full_string,"");
#ifdef DEBUG
  printf("In Siblings, roll = %d\n", roll);
#endif
  sprintf(full_string,"<tr><td align=center><b>Siblings (%d)</b></td><td>\n", 
	roll > 7 ? 0 : roll);
  strcat(family_data,full_string);
  if(roll > 7)
  {
    strcat(family_data,"You are an only child.</td></tr>\n");
    return;
  }
  
  while(roll-- > 0)
  {
    age_roll=D10;
    feel_roll=D10;
    sex_roll=die(2) - 1;
#ifdef DEBUG
  printf("In the multi-sibling loo: age:%d feel:%d sex=%d\n", 
	age_roll, feel_roll, sex_roll);
#endif
  
    /* Age Foo */
    /* First we eliminate duplicate twin outputs. */
    while(strstr(family_data,"Twin") && age_roll == 10)
	age_roll = D10;
    if(age_roll < 6)
	strcpy(age_buff,"Younger");
    else if(age_roll > 5 && age_roll < 10)
	strcpy(age_buff,"Older");
    else
	strcpy(age_buff,"Twin");

    /* Sex Foo */
    if(sex_roll)
        strcpy(sex_buff,"brother");
    else
        strcpy(sex_buff,"sister");

    /* Feelings foo */
    switch(feel_roll)
    {
      case 1:
      case 2:
	strcpy(feel_buff,"dislikes you. ");
	break;
      case 3:
      case 4:
	strcpy(feel_buff,"likes you. ");
	break;
      case 5:
      case 6:
	strcpy(feel_buff,"feels neutral. ");
	break;
      case 7:
      case 8:
	strcpy(feel_buff,"hero worsphips you. ");
	break;
      case 9:
      case 10:
	strcpy(feel_buff,"hates you. ");
	break;
    }

  // Put it all together.
   sprintf(full_string, "%s %s %s<br>", 
	age_buff, sex_buff, feel_buff);
   strcat(family_data,full_string);

  } // Done with sib loop

  strcat(family_data,"</td></tr>\n");
} // End of family foo.


/* Motivations:  Generate the foofey tables on Pg 26 of the Lifepath
   section of the CP2020 manual.    Most of this stuff won't ever
   be used but we'll turn it on, anyway. */

void Lifepath::gen_traits(void)
{
  switch(D10)
  {
    case 1:
	strcpy(traits,"Shy and secretive");
	break;
    case 2:
	strcpy(traits,"Rebellious, antisocial and violent");
	break;
    case 3:
	strcpy(traits,"Arrogant, proud, and aloof");
	break;
    case 4:
	strcpy(traits,"Moody, rash and headstrong");
	break;
    case 5:
	strcpy(traits,"Picky, fussy and nervous");
	break;
    case 6:
	strcpy(traits,"Stable and serious");
	break;
    case 7:
	strcpy(traits,"Silly and fluffheaded");
	break;
    case 8:
	strcpy(traits,"Sneaky and deceptive");
	break;
    case 9:
	strcpy(traits,"Intellectual and detached");
	break;
    case 10:
	strcpy(traits,"Friendly and outgoing");
	break;
  }
}  // end of gen_traits()


void Lifepath::gen_person(void)
{
  switch(D10)
  {
    case 1:
	strcpy(person_valued,"A parent");
	break;
    case 2:
	strcpy(person_valued,"A brother or sister");
	break;
    case 3:
	strcpy(person_valued,"A lover");
	break;
    case 4:
	strcpy(person_valued,"A friend");
	break;
    case 5:
	strcpy(person_valued,"Yourself");
	break;
    case 6:
	strcpy(person_valued,"A pet");
	break;
    case 7:
	strcpy(person_valued,"Teacher or Mentor");
	break;
    case 8:
	strcpy(person_valued,"Public figure");
 	break;
    case 9:
	strcpy(person_valued,"A personal hero");
	break;
    case 10:
	strcpy(person_valued,"No one");
	break;
    }
}  // End of gen_person

void Lifepath::gen_values(void)
{
  switch(D10)
  {
    case 1:
	strcpy(values,"Money");
	break;
    case 2:
	strcpy(values,"Honor");
	break;
    case 3:
	strcpy(values,"Your word");
	break;
    case 4:
	strcpy(values,"Honesty");
	break;
    case 5:
	strcpy(values,"Knowledge");
	break;
    case 6:
	strcpy(values,"Vengeance");
	break;
    case 7:
	strcpy(values,"Love");
	break;
    case 8:
	strcpy(values,"Power");
	break;
    case 9:
	strcpy(values,"Having a good time");
	break;
    case 10:
	strcpy(values,"Friendship");
	break;
    }
} // end of gen_values


void Lifepath::gen_possession(void)
{
  switch(D10)
  {
    case 1:
	strcpy(valued_possession,"A weapon");
	break;
    case 2:
	strcpy(valued_possession,"A tool");
	break;
    case 3:
	strcpy(valued_possession,"A piece of clothing");
	break;
    case 4:
	strcpy(valued_possession,"A photograph");
	break;
    case 5:
	strcpy(valued_possession,"A book or diary");
	break;
    case 6:
	strcpy(valued_possession,"A recording");
	break;
    case 7:
	strcpy(valued_possession,"A musical instrument");
	break;
    case 8:
	strcpy(valued_possession,"A piece of jewelry");
	break;
    case 9:
	strcpy(valued_possession,"A toy");
	break;
    case 10:
	strcpy(valued_possession,"A letter");
	break;
    }
} // End of gen_possession

void Lifepath::gen_feelings(void)
{
  switch(D10)
  {
    case 1:
    case 2:
	strcpy(other_folks,"Neutral");
	break;
    case 3:
	strcpy(other_folks,"I like almost everyone.");
	break;
    case 4:
	strcpy(other_folks,"I hate almost everyone.");
	break;
    case 5:
	strcpy(other_folks,"People are tools.  Use them for your own goals and discard them.");
	break;
    case 6:
	strcpy(other_folks,"Every person is a valuable individual.");
	break;
    case 7:
	strcpy(other_folks,"People are objstacles to be destroyed if they cross me.");
	break;
    case 8:
	strcpy(other_folks,"People are untrustworthy.  Don't depend on anyone.");
	break;
    case 9:
	strcpy(other_folks,"Wipe 'em al out and give the place to the cockroaches");
	break;
    case 10:
	strcpy(other_folks,"People are wonderful.");
	break;
    }
} // End of gen_feelings

// End of Motivation Generation

// Start of yearly events

void Lifepath::year_event(int year)
{
  int i=0;
  i = D10;
#ifdef DEBUG
  printf("In year event, case: %d\n", i);
#endif
  switch(i)
  {
    case 1:
    case 2:
    case 3:
	if(D10 % 2)
	  big_problem(year);
	else
	  big_win(year);
	break;
    case 4:
    case 5:
    case 6:
	if(D10 < 6)
	   gen_friend(year);
	else
#ifdef DEBUG
printf("Generating Enemy\n");
#endif
	   enemy(year);
	break;
    case 7:
    case 8:
        romance(year);
	break;
    case 9:
    case 10:
	strcpy(events[year],"Nothing Happened.");
	break;
    }
} // end of year_event


void Lifepath::big_problem(int year)
{

  switch(D10)
  {
    case 1:
	sprintf(events[year],"You lost %d Eurodollars.  If you can't pay now, you have a dept to pay in cash, or blood.", D10*100);
	break;
    case 2:
	sprintf(events[year],"You were imprisoned for %d months", D10);
	break;
    case 3:
	sprintf(events[year],"Illness or addiction causes 1 pt REF Loss.");
	break;
    case 4:
	switch(D10)
	{
	  case 1:
	  case 2:
	  case 3:
	    sprintf(events[year],"Betrayal: You are being blackmailed.");
	    break;
	  case 4:
	  case 5:
	  case 6:
	  case 7:
	    sprintf(events[year],"Betrayal: A secret was exposed.");
	    break;
	  case 8:
	  case 9:
	  case 10:
	    sprintf(events[year],"You were betrayed by a close friend in either a romanance or career.");
	    break;
	  }
	  break;
    case 5:
	switch(D10)
	{
	  case 1:
	  case 2:
	  case 3:
	  case 4:
	    sprintf(events[year],"You were horribly disfigured. Subtract 5 from your ATT");
	    break;
	  case 5:
	  case 6:
	    sprintf(events[year],"You were hospitalized for %d months.", D10);
	    break;
	  case 7:
	  case 8:
	    sprintf(events[year],"You have lost %d months of memory of this year.", D10);
	    break;
	  case 9:
	  case 10:
	    sprintf(events[year],"You constantly relive nightmares of an accident (8 in 10 per night)");
	    break;
  	}
	break;
    case 6:
	switch(D10)
	{
	  case 1:
	  case 2:
	  case 3:
	  case 4:
	  case 5:
	    sprintf(events[year],"Close friend, lover or relative was killed accidentally.");
	    break;
	  case 6:
	  case 7:
	  case 8:
	    sprintf(events[year],"Close friend, lover or relative was murdered by an unknown party.");
	    break;
	  case 9:
	  case 10:
	    sprintf(events[year],"Close friend, lover or relative was murdered and you know who did it.  You just need proof.");
	    break;
	}
	break;
    case 7:
	switch(D10)
	{
	  case 1:
	  case 2:
	  case 3:
	   sprintf(events[year],"You have been falsely accused of theft.");
	   break;
	  case 4:
	  case 5:
	   sprintf(events[year],"You have been falsely accused of cowardice.");
	   break;
	  case 6:
	  case 7:
	  case 8:
	   sprintf(events[year],"You have been falsely accused of murder.");
	   break;
	  case 9:
	   sprintf(events[year],"You have been falsely accused of rape.");
	   break;
	  case 10:
	   sprintf(events[year],"You have been falsely accused of lying or betrayal.");
	   break;
	}
	break;
    case 8:
	switch(D10)
	{
	  case 1:
	  case 2:
	  case 3:
	    sprintf(events[year],"A couple of local cops are hunting you for a crime you may or may not have committed.");
	    break;
	  case 4:
	  case 5:
	  case 6:
	    sprintf(events[year],"Entire local police force is hunting you for a crime you may or may not have committed.");
	    break;
	  case 7:
	  case 8:
	    sprintf(events[year],"State Police or Militia are hunting you for a crime you may or may not have committed.");
	    break;
	  case 9:
	  case 10:
	    sprintf(events[year],"National police force is hunting you for a crime you may or may not have committed.");
	    break;
	}
	break;
    case 9:
	switch(D10)
	{
	  case 1:
	  case 2:
	  case 3:
	    sprintf(events[year],"You have angered a small, local corp.");
	    break;
	  case 4:
	  case 5:
	  case 6:
	    sprintf(events[year],"You have angered a statewide corporation");
	    break;
	  case 7:
	  case 8:
	    sprintf(events[year],"You have angered a national corporation with agents in major cities nationwide.");
	    break;
	  case 9:
	  case 10:
	    sprintf(events[year],"You have angered a multinational corporation with armies, spies, and ninja everwhere.");
	    break;
	}
	break;
    case 10:
	switch(D10)
	{
	  case 1:
	  case 2:
	  case 3:
	    sprintf(events[year],"Mental or Physical Incapacitation: Nervous Disorder lose 1 pt. Ref");
	    break;
	  case 4:
	  case 5:
	  case 6:
	  case 7:
	    sprintf(events[year],"Mental or Physical Incapacitation: Anxiety and Phobias, lose 1 pt. Cool");
	    break;
	  case 8:
	  case 9:
	  case 10:
	    sprintf(events[year],"Mental or Physical Incapacitation: Major Psychosis; you hear voices and are violent, irrational and depressive.  Lose 1 pt. Ref and 1 pt. Cool");
	    break;
	}
	break;
  }
}  // End of big_problem()

void Lifepath::big_win(int year)
{
  switch(D10)
  {
     case 1:
	switch(D10)
	{
	  case 1:
	  case 2:
	  case 3:
	  case 4:
	    sprintf(events[year],"Made powerful connection in the City Police Department");
	    break;
	  case 5:
	  case 6:
	  case 7:
	    sprintf(events[year],"Made a powerful connection in the City District Attorney's Office.");
	    break;
	  case 8:
	  case 9:
	  case 10:
	    sprintf(events[year],"Made a powerful connect in the City Mayor's office.");
	    break;
	}
	break;
    case 2:
	sprintf(events[year],"Financial Windfall of %d Eurodollars",
	  D10*100);
	break;
    case 3:
	sprintf(events[year],"Big score on a job or deal for %d Eurodollars",
	  D10*100);
	break;
    case 4:
	sprintf(events[year],"Find a Sensei:  Begin at +2 or add +1 to a martial arms skill of your choice.");
	break;
    case 5:
	sprintf(events[year],"Find a teacher:  Add +1 to any INT based skill, or begin a new skill at +2.");
	break;
    case 6:
	sprintf(events[year],"Powerful Corporate Exec owes you one favor.");
	break;
    case 7:
	sprintf(events[year],"Local nomad pack befriends you.  You can call upon them for one favor per month.  Equiv to Family +2");
	break;
    case 8:
	sprintf(events[year],"Make a friend on the police force.  You may use him for inside information at a level of +2 Streetwise on any police related information.");
	break;
    case 9:
	sprintf(events[year],"Local booser gang likes you.  You can call upon them for 1 favor/month. Equiv to Family +2.");
	break;
    case 10:
	sprintf(events[year],"Find a combat teacher.  Add +1 to any weapon skill or begin a new combat skill at +2.");
	break;
  }
}  // End of big_win()

void Lifepath::gen_friend(int year)
{
  switch(D10)
  {
    case 1:
	sprintf(events[year],"Friend: Like a big brother/sister to you.");
	break;
    case 2:
	sprintf(events[year],"Friend: Like a kid sister/brother to you.");
	break;
    case 3:
	sprintf(events[year],"Friend: Partner or co-worker.");
	break;
    case 4:
	sprintf(events[year],"Friend: An old lover.");
	break;
    case 5:
	sprintf(events[year],"Friend: An old enemy.");
	break;
    case 6:
	sprintf(events[year],"Friend: Like a foster parent to you.");
	break;
    case 7:
	sprintf(events[year],"Friend: A relative.");
	break;
    case 8:
	sprintf(events[year],"Friend: Old Childhood Friend");
	break;
    case 9:
    case 10:
	sprintf(events[year],"Friend: Met through common interest.");
	break;
    }
}  // end of friend()

void Lifepath::enemy(int year)
{
  char en_sex[8];
  char en_type[41];
  char en_cause[NBUF];
  char en_fracked[41];
  char en_resources[41];

#ifdef DEBUG
printf("\tEntered enemy().\n");
#endif
  // Figure out the sex
  if(die(2)-1)
	strcpy(en_sex,"Female");
  else
	strcpy(en_sex,"Male");

  // Set the type,origin of the enemy
  switch(D10)
  {
    case 1:
      strcpy(en_type,"ex-friend");
      break;
    case 2:
      strcpy(en_type,"ex-lover");
      break;
    case 3:
      strcpy(en_type,"relative");
      break;
    case 4:
      strcpy(en_type,"childhood enemy");
      break;
    case 5:
      strcpy(en_type,"person working for you");
      break;
    case 6:
      strcpy(en_type,"employer");
      break;
    case 7:
      strcpy(en_type,"partner or co-worker");
      break;
    case 8:
      strcpy(en_type,"booster gang member");
      break;
    case 9:
      strcpy(en_type,"corporate executive");
      break;
    case 10:
      strcpy(en_type,"government official");
      break;
  }

  // Generate the cause of the enemy
  switch(D10)
  {
    case 1:
	strcpy(en_cause,
	  "Caused the other to lose face or status");
 	break;
    case 2:
	strcpy(en_cause,
	  "Caused the loss of a lover, friend or enemy.");
	break;
    case 3:
	strcpy(en_cause,
	  "Caused a major humiliation.");
	break;
    case 4:
	strcpy(en_cause,
	  "Accused the other of cowardice or some other personal flaw.");
        break;
    case 5:
	strcpy(en_cause,
	  "Caused a physical disability.");
	break;
    case 6:
	strcpy(en_cause,
	  "Deserted or betrayed the other.");
	break;
    case 7:
	strcpy(en_cause,
	  "Turned down the other's offer of job or romantic involvement.");
	break;
    case 8:
	strcpy(en_cause,
	  "You just didn't like each other.");
	break;
    case 9:
	strcpy(en_cause,
	  "Was a romantic rival.");
	break;
    case 10:
	strcpy(en_cause,
	  "Foiled a plan of the other's.");
	break;
  }

  // Who's pissed?
  switch(D10)
  {
    case 1:
    case 2:
    case 3:
    case 4:
	strcpy(en_fracked,"They hate you.");
	break;
    case 5:
    case 6:
    case 7:
 	strcpy(en_fracked,"You hate them.");
	break;
    default:
        strcpy(en_fracked,"You hate each other.");
	break;
  }

  // What resources doe the enemy have?
  switch(D10)
  {
    case 1:
    case 2:
    case 3:
	strcpy(en_resources,"Just himself");
	break;
    case 4:
    case 5:
	strcpy(en_resources,"Himself and a few friends");
	break;
    case 6:
    case 7:
 	strcpy(en_resources,"An entire gang.");
	break;
    case 8:
    	strcpy(en_resources,"A small corporation.");
	break;
    case 9:
	strcpy(en_resources,"A large corporation.");
	break;
    case 10:
	strcpy(en_resources,"An entire government agency.");
	break;
  }

  // Put it all together.

  sprintf(events[year],"Enemy: %s %s.  Cause: %s  Feelings: %s Enemy's Resources: %s",
	   en_sex, en_type, en_cause, en_fracked, en_resources);

#ifdef DEBUG
printf("\tLeaving enemy().\n");
#endif

  return;
}  // End of enemy()


void Lifepath::romance(int year)
{

  switch(D10)
  {
    case 1:
    case 2:
    case 3:
    case 4:
      sprintf(events[year],"Happy Love Affair");
      break;

    case 5:
      // Tragic Love Affair
      switch(D10)
      {
        case 1:
	  sprintf(events[year],"Romance: Lover died in an accident.");
	  break;
        case 2:
          sprintf(events[year],"Romance: Lover mysteriously vanished.");
	  break;
	case 3:
	  sprintf(events[year],"Romance: It didn't work out.");
	  break;
	case 4:
	  sprintf(events[year],"Romance: A personal goal or vendetta came between you.");
	  break;
	case 5:
	  sprintf(events[year],"Romance: Lover kidnapped.");
	  break;
	case 6:
	  sprintf(events[year],"Romance: Lover went insane.");
	  break;
	case 7:
	  sprintf(events[year],"Romance: Lover committed suicide.");
	  break;
 	case 8:
	  sprintf(events[year],"Romance: Lover killed in a fight.");
	  break;
	case 9:
	  sprintf(events[year],"Romance: Rival cut you out of the action.");
	  break;
	case 10:
	  sprintf(events[year],"Romance: Lover imprisoned or exiled.");
	  break;
      }     
      break;
    
    case 6:
    case 7:
      //  Love Affair with Problems
      switch(D10)
      {
      	case 1:
	  sprintf(events[year],"Romance: Your lover's friends/family hate you.");
	  break;
	case 2:
	  sprintf(events[year],"Romance: Your lover's friends/family would use any means to get rid of you.");
	  break;
	case 3:
	  sprintf(events[year],"Romance: Your friends/family hate your lover.");
	  break;
	case 4:
	  sprintf(events[year],"Romance: One of you has romantic rival");
	  break;
	case 5:
	  sprintf(events[year],"Romance: You are separated in some way.");
	  break;
	case 6:
	  sprintf(events[year],"Romance: You fight constantly.");
	  break;
	case 7:
	  sprintf(events[year],"Romance: You're professional rivals.");
	  break;
	case 8:
	  sprintf(events[year],"Romance: One of you is insanely jealous.");
	  break;
	case 9:
	  sprintf(events[year],"Romance: One of you is messing around.");
	  break;
	case 10:
	  sprintf(events[year],"Romance: You have conflicting backgrounds and families.");
	  break;
      }
      break;
    default:
      sprintf(events[year],"Fast Affairs and Hot Dates");
      break;
  }
}  // End of romance()

	
void Lifepath::generate_lifepath(int age_diff)
{
  int i;

  // Origins and Personal Style
  if(do_origins)
  {
    gen_clothes();
    gen_hairstyle();
    gen_affections();
    gen_ethnicity();
  }
// Family
  if(do_family)
    family_ranking();  


  // Motivations
  if(do_motivations)
  {
    gen_traits();
    gen_person();
    gen_values();
    gen_possession();
    gen_feelings();
  }


  // Life Events
  if(do_events)
  {
    for(i=0;i<age_diff;i++)
      year_event(i);
  }

  output_lifepath_html(age_diff);

}  // End of gen_lifepath()

void Lifepath::output_lifepath_html(int years)
{
  int i;

  // Get the header data for the page out.
  fprintf(cgiOut,"<html><head>\n");
  fprintf(cgiOut,"<title>Lifepath Generated for %s</title>\n", namebuf);
  fprintf(cgiOut,"</head><body bgcolor=\"#ffffff\">\n");
  fprintf(cgiOut,"<font face=\"Helvetica, Arial, Times\">\n");
  // Setup the table, two cells per row, width 100%
  fprintf(cgiOut,"<table width=100%% border=1 cellpadding=3>\n");

  // Header rows
  fprintf(cgiOut,"<tr><td colspan=2 align=center bgcolor=#dddddd>\n");
  fprintf(cgiOut,"<font size=+2>Cyberpunk 2020 Lifepath Generation");
  fprintf(cgiOut,"</font><br><font size=-1>\n");
  fprintf(cgiOut,"
    <a href=\"http://lost.strange.com/cp2020/lifepath-form.html\">\n");
  fprintf(cgiOut,"http://lost.strange.com/cp2020/lifepath-form.html</a>\n");
  fprintf(cgiOut,"<br> &copy; - GNU General Public License</font><hr width=20%%>\n");
  fprintf(cgiOut,"<font size=+1>Lifepath for %s\n</font>", namebuf);
  fprintf(cgiOut,"</td></tr>\n");

  if(do_origins)
  {
    fprintf(cgiOut,"<tr><td colspan=2  bgcolor=#dddddd>\n");
    fprintf(cgiOut,"<font size=+1>Origins & Personal Style</font>");
    fprintf(cgiOut,"</td></tr>\n");

    fprintf(cgiOut,"<tr><td align=center><b>Clothes</b></td><td>%s</td></tr>\n", 
      	clothes);
    fprintf(cgiOut,"<tr><td align=center><b>Hairstyle</b></td><td>%s</td></tr>\n", 
    	hairstyle);
    fprintf(cgiOut,"<tr><td align=center><b>Affections</b></td><td>%s</td></tr>\n",
	affections);
    fprintf(cgiOut,"<tr><td align=center><b>Ethnicity</b></td><td>%s</td></tr>\n",
	ethnicity);
  }

  if(do_family)
  {
    fprintf(cgiOut,"<tr><td colspan=2  bgcolor=#dddddd>\n");
    fprintf(cgiOut,"<font size=+1>Family Background</font>");
    fprintf(cgiOut,"</td></tr>\n");

    fprintf(cgiOut,"%s\n",
	family_data);
  }

  if(do_motivations)
  {
    fprintf(cgiOut,"<tr><td colspan=2  bgcolor=#dddddd>\n");
    fprintf(cgiOut,"<font size=+1>Motivations</font>");
    fprintf(cgiOut,"</td></tr>\n");
 
    fprintf(cgiOut,"<tr><td align=center><b>Traits</b></td><td>%s</td></tr>\n",
	traits);
    fprintf(cgiOut,"<tr><td align=center><b>Person Valued Most</b></td><td>%s</td></tr>\n",
	person_valued);
    fprintf(cgiOut,"<tr><td align=center><b>Valued Most</b></td><td>%s</td></tr>\n",
	values);
    fprintf(cgiOut,"<tr><td align=center><b>Valued Possession</b></td><td>%s</td></tr>\n",
	valued_possession);
    fprintf(cgiOut,"<tr><td align=center><b>Feeling about most people</b></td><td>%s</td></tr>\n",
	other_folks);
  }

  if(do_events)
  {
    fprintf(cgiOut,"<tr><td colspan=2  bgcolor=#dddddd>\n");
    fprintf(cgiOut,"<font size=+1>Life Events</font>");
    fprintf(cgiOut,"</td></tr>\n");

    for(i=0; i < years; i++)
    {
      fprintf(cgiOut,"<tr><td align=center><b>Age %d</b></td><td>%s</td></tr>\n",
	min+i, events[i]);
    }
  }
  fprintf(cgiOut,"</table><p></body></html>\n");

}
 
int cgiMain(void)
{
  int age_diff=0;
  class Lifepath L;
 
  srand(generate_seed());

// Output the header, just in case
  cgiHeaderContentType("text/html");

// Fetch the data, we hope.
  cgiFormStringNoNewlines("in-name", namebuf, 79);
  cgiFormIntegerBounded("min-age", &min, 8, 100, 16);
  cgiFormIntegerBounded("max-age", &max, min, 100, 28);
  
// Fetch the options
  if(cgiFormCheckboxSingle("do-origins") == cgiFormSuccess)
    do_origins = 1;
  else
    do_origins = 0;

  if(cgiFormCheckboxSingle("do-family") == cgiFormSuccess)
    do_family = 1;
  else 
    do_family = 0;

  if(cgiFormCheckboxSingle("do-motivations") == cgiFormSuccess)
    do_motivations = 1;
  else
    do_motivations = 0;

  if(cgiFormCheckboxSingle("do-events") == cgiFormSuccess)
    do_events = 1;
  else
    do_events = 0;

// Do the age range calcs with safety for buffer overflow on events array
  age_diff = max - min +1;
  if( age_diff  > 40)
     age_diff=39;

  L.generate_lifepath(age_diff);

return 0;
}
  




