/*
   Author: Mark A. Hassman  (mark@lost.strange.com)
   Version: 1.0
   Copyright:  GNU General Public License
*/
#include "copyright.h"

#include <string.h>
#include "dice.h" 	/* DX defs */
#include "gma.h"   	/* Prototype for die() */

#define NBUF 	 81  /* A normal sized buffer */
#define LBUF 	256  /* A large buffer */
#define HBUF	1024 /* A huge buffer */


extern int die(int n);

class Lifepath
{
private:
	char clothes[NBUF];	  // What or what isn't he wearing?
	char hairstyle[NBUF];	  // Simple Hair Styles
	char affections[NBUF];    // Foofey affections
	char ethnicity[NBUF];     // Short ethnic type string
	char family_data[HBUF];   // Stores all of the family data
	char traits[NBUF];	  // Personality Traits
	char person_valued[NBUF]; // What person does he value
	char values[NBUF];	  // What intangible value
	char valued_possession[NBUF]; // Object of value
	char other_folks[NBUF];	  // How does X feel about others
	char events[40][LBUF];

	/* General Generation Functions */
	void gen_clothes(void);
	void gen_hairstyle(void);
	void gen_affections(void);
	void gen_ethnicity(void);

	/* Functions used in family generation */
	void family_ranking(void);
	void parents(void);
	void parent_event(void);
	void family_status(void);
	void child_environ(void);
	void family_tragedy(void);
	void siblings(void);

	/* Motivations for the NPC */
	void gen_traits(void);
	void gen_person(void);
	void gen_values(void);
	void gen_possession(void);
	void gen_feelings(void);

	/* Yearly Events */
	  
	void year_event(int);
	void big_problem(int);
	void big_problem_response(int);  // Not included in v1.0
	void big_win(int);
	void gen_friend(int);
 	void enemy(int);
	void romance(int);

public:
	void generate_lifepath(int);
	void output_lifepath_html(int);
};


// Globals
int min, max;
char namebuf[81];
int do_origins;
int do_family;
int do_motivations;
int do_events;
