/*
   Author: Mark A. Hassman  (mark@lost.strange.com)
   Version: 1.0
   Copyright:  GNU General Public License
*/
#include "copyright.h"


// name.cpp
//  Random name generation routines.
//   Uses 'modern' style names.
//	Mark A. Hassman	1/20/97

#include "name.h"
#include <stdio.h>
#include <string.h>
#include "gma.h"
#include <stddef.h>
#include <stdlib.h>

NAME::NAME(void)
{
	strcpy(alpha,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
	first[0]=mi[0]=last[0]='\0';
	sur_cnt = male_cnt = female_cnt = 0;
}

void NAME::setup_name(void)
{
	FILE *Surname, *Male, *Female;
	char buff[80];
	int i;

	strcpy(alpha,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
	first[0]=mi[0]=last[0]='\0';

	Surname=fopen("/home/data/punk/surname.dat","r");
	Male=fopen("/home/data/punk/males.dat","r");
	Female=fopen("/home/data/punk/female.dat","r");

	if(!Male || !Female || !Surname)
	{
		printf("Error opening name files\n");
		exit(-3);
	}

	i=0;
        strcpy(buff,"");
	while(Surname && buff[0] != '\n')
	{
		fgets(buff,79,Surname);
		i++;
	
	}
	sur_cnt = i;
	fclose(Surname);
	i=0;
        strcpy(buff,"");
	while(Male && buff[0] != '\n')
	{
		fgets(buff,79,Male);
		if(buff[0])
			i++;
	}
	male_cnt = i;
	i=0;
	fclose(Male);
	strcpy(buff,"");
	while(Female && buff[0] != '\n')
	{
		fgets(buff,79,Female);
		i++;
	}
	female_cnt = i;
	fclose(Female);
	return;
}


void NAME::gen_name(int Sex)
{
	FILE *Surname, *First;
	char buff[45];
	int roll,i;
	
	setup_name();

// old	Sex=die(2)-1;
	if(Sex == 1)  // Male
	{
		First=fopen("/home/data/punk/males.dat","r");
		Surname=fopen("/home/data/punk/surname.dat","r");
		if(!First || !Surname)
		{
			printf("Error opening names in gen_name.\n");
			exit(-3);
		}

		if(male_cnt == 0 || sur_cnt == 0)
		{
			printf("Name counts off, exit.");
			exit(0);
		}

		roll=die(male_cnt)-1;
		i=0;
		while(i <= roll)
		{
			fgets(buff,44,First);
			if(i == roll)
			{
				strcpy(first,buff);
				break;
			}
			else
				i++;
		
		}

		roll=die(sur_cnt)-1;
		i=0;
		while(i <= roll)
		{
			fgets(buff,44,Surname);
			if(i == roll)
			{
				strcpy(last,buff);
				break;
			}
			else
				i++;
		}

	}
	else  // Female
	{
		First=fopen("/home/data/punk/female.dat","r");
		Surname=fopen("/home/data/punk/surname.dat","r");
		if(!First || !Surname)
		{
			printf("Error opening names in gen_name.\n");
			exit(-3);
		}
		if(female_cnt == 0 || sur_cnt == 0)
		{
			printf("Name counts bad. Fem: %d  Sur %d\n",
				female_cnt, sur_cnt);
			exit(0);
		}



		roll=die(female_cnt)-1;
		i=0;
		while(i <= roll)
		{
			fgets(buff,44,First);
			if(i == roll)
			{
				strcpy(first,buff);
				break;
			}
			else
				i++;
		}

		roll=die(sur_cnt)-1;
		i=0;
		while(i <= roll)
		{
			fgets(buff,44,Surname);
			if(i == roll)
			{
				strcpy(last,buff);
				break;
			}
			else
				i++;
		}

	}

	first[strlen(first)-1]='\0';
	last[strlen(last)-1]='\0';
	// Do we want a middle inital (50%)
	if(D100 > 50)
	{
		mi[0]=alpha[die(26)-1];
		mi[1]='\0';
	}
}

void NAME::gen_fullname(int Sex)
{
	char buff[80];

	// generate the name
	gen_name(Sex);

	if(!first[0] || !last[0])
	{
		return;
		printf("Error in return_name.\n");
		exit(-3);
	}

	strcpy(buff,first);
	strcat(buff," ");
	if(mi[0])
	{
		strcat(buff,mi);
		strcat(buff,". ");
	}
	strcat(buff,last);
	strcpy(fullname,buff);
}
