/*
   Author: Mark A. Hassman  (mark@lost.strange.com)
   Version: 1.0
   Copyright:  GNU General Public License
*/
#include "copyright.h"

// random.cpp for GMA

#include "gma.h"

/* This code profiled through a run of 1,000,000
   iterations of a d10, gave a maximum variance
   of +/- 0.35 percent during the 10 runs.  
  */

unsigned int generate_seed(void)
{
	struct tm then_st = {0};
	time_t then_t;
	
	then_st.tm_year=95;
	then_st.tm_mon = 1;
	then_st.tm_mday = 1;

	then_t = mktime(&then_st);

	if(then_t == (time_t) -1)
	{
		fprintf(stderr,"Error in generate seed.\n");
		exit(-1);
	}

	return (int) difftime(time(NULL),then_t) % RAND_MAX;
}

int die(int n)
{
   if(n > 0)
	return (rand()%n)+1;
   else
	return 0;
}
