/*
   Author: Mark A. Hassman  (mark@lost.strange.com)
   Version: 1.0
   Copyright:  GNU General Public License
*/
#include "copyright.h"


/* Weapon Routines for FDE Generation */

#include <stdio.h>
#include "gma.h"
#include "cgic.h"

// Weapon Types
#define PISTOL 	1
#define SMG	2
#define RIFLE 	3
#define SHOTGUN 4
#define HEAVY	5
#define EXOTIC	6
#define MELEE	7

// Datafiles
#define PISTOL_DB	"data/pistols.dat"
#define SMG_DB		"data/smg.dat"
#define RIFLE_DB	"data/rifles.dat"
#define SHOTGUN_DB	"data/shotguns.dat"
#define HEAVY_DB	"data/heavy.dat"
#define EXOTIC_DB	"data/exotics.dat"
#define MELEE_DB	"data/melee.dat"

#define WEAPON_READ_FMT "%s|%d|%c|%c|%s|%d|%d|%s|%s|%d"

class WEAPON
{
private:
	char Name[65];
	char Type[6];
	int WA;
	char Con;
	char Avail;
	char Dmg[25];
	int Shots;
	int ROF;
	char Rel[3];
	char Range[10];
	int Cost;
public:
	WEAPON();
	void gen_weapon(int ID);
	void display_weapon_html(void);

};
